const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const routings = sequelize.define(
    'routings',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

routing_code: {
        type: DataTypes.TEXT,
      
      

      },

revision_status: {
        type: DataTypes.ENUM,
      
      

        values: [

"draft",


"released",


"obsolete"

        ],

      },

revision: {
        type: DataTypes.TEXT,
      
      

      },

effective_from: {
        type: DataTypes.DATE,
      
      

      },

effective_to: {
        type: DataTypes.DATE,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  routings.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity


















    db.routings.hasMany(db.routing_operations, {
      as: 'routing_operations_routing',
      foreignKey: {
          name: 'routingId',
      },
      constraints: false,
    });


    db.routings.hasMany(db.production_orders, {
      as: 'production_orders_routing',
      foreignKey: {
          name: 'routingId',
      },
      constraints: false,
    });












    db.routings.hasMany(db.documents, {
      as: 'documents_routing',
      foreignKey: {
          name: 'routingId',
      },
      constraints: false,
    });



//end loop



    db.routings.belongsTo(db.items, {
      as: 'item',
      foreignKey: {
        name: 'itemId',
      },
      constraints: false,
    });




    db.routings.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.routings.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return routings;
};


